-- Ŀ
--  System.E  V1.03 (C) 1996 PJB Systems            System specific libraray 
-- 

include file.e

integer CPU
global constant Intel = 80386
global constant Motorola = 68000

CPU = Intel

-------------------------------------------------------------------------------
global function NormalizeFilename(sequence fn)
  integer byt
  sequence fn2
  fn2 = {}
  for idx = 1 to length(fn) do
    byt = fn[idx]
    if (byt > 96) and (byt < 123) then -- Convert to upper case
      byt = byt - 32
    end if
    if (byt > 32) and (byt < 91)  then -- Accept char
      fn2 = fn2 & byt
    end if
  end for
  return fn2
end function

-------------------------------------------------------------------------------
global function GetIntVector(atom i)
  integer add,off,seg
  add = i * 4
  off = peek(add) + (peek(add + 1) * 256)
  seg = peek(add + 2) + (peek(add + 3) * 256)
  return off + (seg * 16)
end function

-- Read Signed byte from file FN ---------------------------------------------
global function ReadSgnByte(atom fn)
  integer b
  b = getc(fn)
  if b > 127 then
    return b - 256
  else
    return b
  end if
end function

-- Read Intel integer from file FN --------------------------------------------
global function ReadIntI86(atom fn)
  return getc(fn) + (getc(fn)*256)
end function

-- Read Motorola integer from file FN -----------------------------------------
global function ReadIntM68(atom fn)
  return (getc(fn)*256) + getc(fn)
end function

-- Read integer from file FN --------------------------------------------------
global function ReadInt(atom fn)
  if CPU = Intel then
    return ReadIntI86(fn)
  elsif CPU = Motorola then
    return ReadIntM68(fn)
  end if
end function

-- Read Intel long-int from file FN -------------------------------------------
global function ReadLongI86(atom fn)
  return getc(fn) + (getc(fn)*256) + (getc(fn)*65536) + (getc(fn)*16777216)
end function

-- Read Motorola long-int from file FN ----------------------------------------
global function ReadLongM68(atom fn)
  return  (getc(fn)*16777216) + (getc(fn)*65536) + (getc(fn)*256) + getc(fn)
end function

-- Read long-int from file FN -------------------------------------------------
global function ReadLong(atom fn)
  if CPU = Intel then
    return ReadLongI86(fn)
  elsif CPU = Motorola then
    return ReadLongM68(fn)
  end if
end function

-- Write long-int N to file FN ------------------------------------------------
global procedure WriteLongI86(atom fn,atom n)
  puts(fn,remainder(n,256))
  n = n / 256
  puts(fn,remainder(n,256))
  n = n / 256
  puts(fn,remainder(n,256))
  n = n / 256
  puts(fn,n)
end procedure

-- Write Motorola long-int N to file FN ---------------------------------------
global procedure WriteLongM68(atom fn,atom n)
  integer b1,b2,b3,b4
  b1 = remainder(floor(n),256)
  n = n / 256
  b2 = remainder(floor(n),256)
  n = n / 256
  b3 = remainder(floor(n),256)
  n = n / 256
  b4 = remainder(floor(n),256)
  puts(fn,b4)
  puts(fn,b3)
  puts(fn,b2)
  puts(fn,b1)
end procedure

-------------------------------------------------------------------------------
global procedure WriteLong(atom fn,atom n)
  if CPU = Intel then
    WriteLongI86(fn,n)
  elsif CPU = Motorola then
    WriteLongM68(fn,n)
  end if
end procedure

-- Write int N to file FN -----------------------------------------------------
global procedure WriteIntI86(atom fn,atom n)
  puts(fn,remainder(n,256))
  n = n / 256
  puts(fn,n)
end procedure

-- Write Motorola int N to file FN --------------------------------------------
global procedure WriteIntM68(atom fn,atom n)
  integer b1,b2
  b1 = remainder(floor(n),256)
  n = n / 256
  b2 = remainder(floor(n),256)
  puts(fn,b2)
  puts(fn,b1)
end procedure

-------------------------------------------------------------------------------
global procedure WriteInt(atom fn,atom n)
  if CPU = Intel then
    WriteIntI86(fn,n)
  elsif CPU = Motorola then
    WriteIntM68(fn,n)
  end if
end procedure

-- Return file extension as a sequence -----------------------------------------
global function Extension(sequence e)
  integer ptr,eos
  ptr = length(e)
  eos = ptr
  for idx = length(e) to 1 by -1 do
    if e[idx] = 46 then
      ptr = idx
      exit 
    end if
  end for
  return e[ptr..eos]
end function

-- Return pointer to file extension --------------------------------------------
global function ExtensionPtr(sequence e)
  integer ptr
  ptr = length(e)
  for idx = length(e) to 1 by -1 do -- Scan from last char to first
    if e[idx] = 46 then
      ptr = idx
      exit 
    end if
  end for
  return ptr
end function

-------------------------------------------------------------------------------
global function ParentDir(sequence p)
  integer ptr
  ptr = 0
  for idx = length(p) - 1 to 1 by -1 do
    if p[idx] = 92 then
      ptr = idx
      exit 
    end if
  end for
  return p[1..ptr]
end function

-------------------------------------------------------------------------------
global function GetDir(sequence p)
  object tmp1
  sequence tmp2,dirs,files
  integer a,b
  tmp1 = dir(p)
  
  if sequence(tmp1) then
    a = 1
    b = length(tmp1)
    if compare(tmp1[1][1],".") = 0 then -- Clip of "."
      a = 2
    end if
    dirs = {}
    files = {}
    for i = a to b do
      if compare(tmp1[i][2],"d") = 0 then
	dirs = dirs & {tmp1[i]}
      else
	files = files & {tmp1[i]}
      end if
    end for
    tmp2 = dirs & files
  else
    tmp2 = {}
  end if
  
  return tmp2
end function

-------------------------------------------------------------------------------
-- This will return a list of PHYSICAL floppy and hard drives
global function GetDriveList()
  integer hdn,fdn
  sequence dl

  fdn = floor(peek(#410) / 64)
  if fdn = 0 then
    dl = "A"
  elsif fdn = 1 then
    dl = "AB"
  end if
  
  hdn = peek(#475)
  if hdn = 1 then
    dl = dl & "C"
  elsif hdn = 2 then
    dl = dl & "CD"
  end if
  
  return dl
end function


